﻿Imports System
Imports System.Windows.Forms
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        WinformsMap1.MapUnit = GeographyUnit.DecimalDegree
        WinformsMap1.CurrentExtent = New RectangleShape(-177.333203125, 92.96484375, 82.823046875, -89.84765625)
        WinformsMap1.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean)

        Dim worldLayer As New ShapeFileFeatureLayer("C:\Program Files (x86)\ThinkGeo\Map Suite Desktop Full Edition 4.0\Samples\SampleData\Data\Countries02.shp")
        worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green))

        Dim highlightLayer As New InMemoryFeatureLayer()
        highlightLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        highlightLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(100, GeoColor.StandardColors.DarkGreen))

        Dim worldOverlay As New LayerOverlay()
        worldOverlay.Layers.Add("WorldLayer", worldLayer)
        WinformsMap1.Overlays.Add("WorldOverlay", worldOverlay)

        Dim highlightOverlay As New LayerOverlay()
        highlightOverlay.Layers.Add("HighlightLayer", highlightLayer)
        WinformsMap1.Overlays.Add("HighlightOverlay", highlightOverlay)

        WinformsMap1.Refresh()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim worldLayer As FeatureLayer = WinformsMap1.FindFeatureLayer("WorldLayer")
        Dim highlightLayer As InMemoryFeatureLayer = DirectCast(WinformsMap1.FindFeatureLayer("HighlightLayer"), InMemoryFeatureLayer)

        worldLayer.Open()
        Dim feature As Feature = worldLayer.QueryTools.GetFeatureById("135", New String(-1) {})
        worldLayer.Close()

        With WinformsMap1.EditOverlay
            .EditShapesLayer.Open()
            .EditShapesLayer.EditTools.BeginTransaction()
            .EditShapesLayer.InternalFeatures.Clear()
            .EditShapesLayer.EditTools.Add(feature)
            Dim result As TransactionResult = .EditShapesLayer.EditTools.CommitTransaction()
            .EditShapesLayer.BuildIndex()
            .EditShapesLayer.Close()
            .CalculateAllControlPoints()
            'Add Index build here.
            .ExistingControlPointsLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear()
            .ExistingControlPointsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.SimpleColors.LightRed, 5)
        End With

        With WinformsMap1.EditOverlay
            .EditShapesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
            .EditShapesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
            .CanAddVertex = True
            .CanDrag = False
            .CanRotate = False
            .CanRemoveVertex = True
            .CanReshape = True
            .CanResize = False
        End With

        WinformsMap1.Refresh(WinformsMap1.EditOverlay)
    End Sub
End Class
